HDU-1041-Computer Transformation(规律题 && 大数题)

Computer Transformation

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 6543    Accepted Submission(s): 2378

Problem Description

A sequence consisting of one digit, the number 1 is initially written into a computer. At each successive time step, the computer simultaneously tranforms each digit 0 into the sequence 1 0 and each digit 1 into the sequence 0 1. So, after the first time step,
the sequence 0 1 is obtained; after the second, the sequence 1 0 0 1, after the third, the sequence 0 1 1 0 1 0 0 1 and so on.

How many pairs of consequitive zeroes will appear in the sequence after n steps?

Input

Every input line contains one natural number n (0 < n ≤1000).

Output

For each input n print the number of consecutive zeroes pairs that will appear in the sequence after n steps.

Sample Input

2
3

Sample Output

1
1

Source

Southeastern Europe 2005

Recommend

JGShining   |   We have carefully selected several similar problems for you:  1006 1030 1032 1007 1143

首先解释一下题目:

题目的大概意思很简单,就是说电脑里面存了一个初始的数字1,后面的所有规律和操作都从1开始,然后每一次产生一个变换,变换的法则如下

即 在这个数列中所有的1变换成01,所有的0变换成10,这样说可能还不明确,从1 开始,下一次则得到01(1->01),再下次则得到1001(上一次的0->10,1->01)然后得到01101001,然后依次类推.......问你经过n次变换有多少组00!(consequitive意为连续,相同的意思!)

参考网友:星夜&永恒的推理:

00只能由01推到,即01->1001->00

01只能由1,00推到,即1->01,00->1010->01.

现设a[n]表示n秒时1的个数,

b[n]表示n秒时00的个数,

c[n]表示n秒时01的个数,

由题知0,1过一秒都会产生一个1,

所以a[n+1]=2^n.....0秒1个数,1秒2*1个数,2秒2*1*2个数,...n秒2*1*2*2*2..*2个数=2^n.

b[n+1]=c[n];

c[n+1]=a[n]+b[n],

所以b[n]=c[n-1]=a[n-2]+b[n-2]=2^(n-3)+b[n-2].

其实本题多写几个样例就能发现另一个规律b[n]=2*b[n-2]+b[n-1].

注意本题大数相加.

/*
 * 依据递推式:b[n]=2*b[n-2]+b[n-1]
 */

import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Main
{

	public static void main(String[] args)
	{
		// TODO Auto-generated method stub
		Scanner input = new Scanner(System.in);
		BigInteger a[] = new BigInteger[1001];
		BigInteger b[] = new BigInteger[1001];
		a[0] = BigInteger.ONE;
		b[2] = BigInteger.ONE;
		b[0] = BigInteger.ZERO;
		b[1] = BigInteger.ZERO;
		for (int i = 1; i < 1001; i++)
		{
			a[i] = a[i - 1].multiply(BigInteger.valueOf(2));   //这里算a[i]的但是这里的a[i]=2^(i-2)
			if (i >= 3)					  //所以下面算b[i]时候要i要多减去一个1
			{
				b[i] = a[i - 3].add(b[i - 2]);
			}
		}
		while (input.hasNext())
		{
			int n = input.nextInt();
			System.out.println(b[n]);
		}
	}

}
时间: 2024-10-11 09:17:17

HDU-1041-Computer Transformation(规律题 && 大数题)的相关文章

HDU 1041 Computer Transformation(找规律加大数乘)

主要还是找规律,然后大数相乘 #include<stdio.h> #include<string.h> #include<math.h> #include<time.h> #include<map> #include<iostream> #include<ctype.h> #include<string> #include<algorithm> #include<stdlib.h> #i

HDU 1041[Computer Transformation] 递推 高精度

题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=1041 题目大意:初始数字1.规则1变成01,0变成10.问经过N次完整变换后,有多少连续零对. 关键思想:考虑零对的直接来源只有"10",而"10"的直接来源只有"1"或者"00".于是可以得到以下几种递推式 1. dp[i]=pow(2,i-3)+dp[i-2];当前层多少1,下一层就多少10,下下层就多少00:当前层多少00,

HDU 1041 Computer Transformation 数学DP题解

本题假设编程是使用DP思想直接打表就能够了. 假设是找规律就须要数学思维了. 规律就是看这些连续的0是从哪里来的. 我找到的规律是:1经过两次裂变之后就会产生一个00: 00经过两次裂变之后也会产生新的00:故此须要记录好1和00出现的次数就能够递推出后面的00出现的数据了. 公式就是tbl00[i] = tbl00[i-2] + tbl1[i-2]; 当中tbl00是记录00出现的次数,tbl1是出现1出现的次数. 公式事实上是能够化简的,只是我懒得化简了.这种公式非常清楚了. 只是因为这种数

HDU 4952 Number Transformation 规律题

打表可以知道到后面增量都一样了,, 推论就是  i 和 i+1 互质 #include <cstdio> #include <algorithm> #include <cstring> #include <iostream> using namespace std; typedef long long ll; const ll mx = 120000; int main() { int cas = 0; ll x, k, y, dis, i; while (

H - Computer Transformation(简单数学题+大数)

H - Computer Transformation Time Limit:1000MS     Memory Limit:32768KB     64bit IO Format:%I64d & %I64u Submit Status Practice _ Appoint description:  System Crawler  (Oct 10, 2016 1:02:59 PM) Description A sequence consisting of one digit, the numb

2014 HDU多校弟八场H题 【找规律把】

看了解题报告,发现看不懂 QAQ 比较简单的解释是这样的: 可以先暴力下达标,然后会发现当前数 和 上一个数 的差值是一个 固定值, 而且等于当前数与i(第i个数)的商, 于是没有规律的部分暴力解决,有规律的套公式 //#pragma comment(linker, "/STACK:16777216") //for c++ Compiler #include <stdio.h> #include <iostream> #include <cstring&g

HDU 1715 大菲波数(JAVA, 简单题,大数)

题目 //BigInteger 和 BigDecimal 是在java.math包中已有的类,前者表示整数,后者表示浮点数 import java.io.*; import java.util.*; import java.math.*; public class Main { /** * @xqq */ public BigInteger an(BigInteger a, BigInteger b, int n) { if(n == 1) { return a; } for(int i = 2

HDU 4937 Lucky Number 规律题_(:зゝ∠)_

把所有合法的进制打出来会发现合法的进制都是在 n/3 n/4 n/5的边上 然后暴力边上的进制数.. #include <cstdio> #include <set> typedef long long ll; bool ok(ll x, ll y) { ll v; while (x > 0) { v = x % y; if (v != 3 && v != 4 && v != 5 && v != 6) return false;

hdu_1041(Computer Transformation) 大数加法模板+找规律

Computer Transformation Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 8367    Accepted Submission(s): 3139 Problem Description A sequence consisting of one digit, the number 1 is initially wri